    /*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package hotel;

/**
 *
 * @author admin
 */
import java.util.*;

public class GuestCollection {

    private List<Guest> guests;

    public GuestCollection() {
        guests = new ArrayList<Guest>();
    }

    public boolean addGuest(Guest aGuest) {
        guests.add(aGuest);
        return true;
    }
    public boolean registerGuest(String guestNo, String name, String address, int phoneNo) {
        Guest aGuest = new Guest(guestNo, name, address, phoneNo);
        guests.add(aGuest);
        return true;
    }
    public String allGuestsData() {
        String s = "";
        for (Guest g : guests) {
            s = s + g.guestData() + "\n";
        }
        return s;
    }
    @Override
    public String toString() {
        return guests.toString();
    }

    public int numberOfGuests() {
        return guests.size();
    }
    public Guest getGuest(String guestNo) {
        String myGuestNo;
        for (Guest g : guests) {
            myGuestNo = g.getGuestNo();
            if (myGuestNo.equals(guestNo)) {
                return g;
            }
        }
        return null; 

    }

    public Guest getGuest(int index) {
        if (index >= 0 && index < guests.size()) {
            Guest g =  guests.get(index);
            return g;
        } else {
            return null;
        }
    }
    public Guest removeGuest(String guestNo) {
        String myGuestNo;
        for (Guest g : guests) {
            myGuestNo = g.getGuestNo();
            if (myGuestNo.equals(guestNo)) {
                guests.remove(g);
                return g;
            }
        }
        return null; 

    }

 
    public Guest removeGuestNew(String guestNo) {
        Guest aGuest = getGuest(guestNo);
        if (aGuest != null) {
            guests.remove(aGuest);
        }
        return aGuest;
    }

    public boolean removeGuest(Guest b) {
        return guests.remove(b);

    }

    public Guest removeGuest(int index) {
        if (index >= 0 && index < guests.size()) {
            Guest aGuest = (Guest) guests.get(index);
            guests.remove(index);
            return aGuest;
        } else {
            return null;
        }
    }

    public void editGuest(String guestNo, String newGuestNo, String name, String address, int phoneNo, String state) {

        for (Guest b : guests) {

            if (b.getGuestNo().equals(guestNo)) {
                b.setGuestNo(newGuestNo);
                b.setName(name);
                b.setAddress(address);
                b.setPhoneNo(phoneNo);
                b.setState(state);
            }
        }
    }

    public boolean editGuest1(Guest oldGuest, Guest newGuest) {
        int index = guests.indexOf(oldGuest);
        if (index > -1) {
            guests.set(index, newGuest);
            return true;
        } else {
            return false;
        }
    }

    public Guest replaceGuest(String guestNo, Guest guest) {
        Guest aGuest;
        String myGuestNo;
        for (int index = 0; index < guests.size(); index++) {
            aGuest = (Guest) guests.get(index);
            myGuestNo = aGuest.getGuestNo();
            if (myGuestNo.equals(guestNo)) {
                guests.set(index, guest);
                return aGuest;
            }
        }
        return null;
    }
    public boolean insertGuest(Guest guest, int index) {
        if (index >= 0 && index < guests.size()) {
            guests.add(index, guest);
            return true;
        } else {
            return false;
        }
    }

    public GuestCollection getGuestsByName(String name) {
        Guest aGuest;
        String myName;
        GuestCollection foundGuests = new GuestCollection();
        for (int index = 0; index < guests.size(); index++) {
            aGuest = (Guest) guests.get(index);
            myName = aGuest.getName();
            if (myName.equals(name)) {
                foundGuests.addGuest(aGuest);
            }
        }
        return foundGuests;
    }

    public static void main(String[] args) {
        // TODO code application logic here
        GuestCollection guestCol = new GuestCollection();

        Guest g1 = new Guest("150561-7777", "TheBoss", "2650 Hvidovre", 20053433);
        Guest g2 = new Guest("15081-7777", "Zhen Zhao", "2620 Albertslund", 20065646);
        Guest g3 = new Guest("10080-7777", "Vaida Caiser", "2100 Københaven Ø", 20054346);
        guestCol.addGuest(g1);
        guestCol.addGuest(g2);
        guestCol.addGuest(g3);

        System.out.println(guestCol.allGuestsData());
//        System.out.println(guestCol.toString()); 
//
//        guestCol.registerGuest("090378-7777", "Simge Ozgul", "2600 Glostrop", 20095678);
//        guestCol.registerGuest("090489-7777", "Peter Rabbit", "4600 Køge", 20096533);
//        System.out.println(guestCol.allGuestsData());
        System.out.println("Number of Guests " + guestCol.numberOfGuests());

    }
}
