/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package hotelbooking;

/**
 *
 * @author admin
 */

import hotel.*;
public class BookingAdministration {
 public BookingAdministration() {
        bookingCol = new BookingCatalog();
    }

    public BookingAdministration(GuestCollection guestCol, RoomCatalog roomCat) {
        bookingCol = new BookingCatalog();
        this.guestCol = guestCol;
        this.roomCat = roomCat;
    }
    BookingCatalog bookingCol;
    GuestCollection guestCol;
    RoomCatalog roomCat;

    public BookingCatalog getCollection() {
        return bookingCol;
    }

    public Guest getGuest(String guestNo) {
        return guestCol.getGuest(guestNo);
    }

    public Room getRoom(String roomNo) {
        return roomCat.getRoom(roomNo);
    }

    public boolean registerBookingInfo(String guestNo, String roomNo) {
        Guest guest = guestCol.getGuest(guestNo);
        Room room = roomCat.getRoom(roomNo);
        if ((guest != null) && (room != null)) {
            bookingCol.registerBooking(guestNo, roomNo, guest, room);
            return true;
        } else {
            return false;
        }
    }

    public boolean addBooking(Booking booking) {
        bookingCol.addBooking(booking);
        return true;
    }

    public Booking getBooking(String roomNo) {
        return bookingCol.getBooking(roomNo);
    }

    public Booking removeBooking(String roomNo) {
        return bookingCol.removeBooking(roomNo);
    }

    boolean insertBooking(int index, Booking booking) {
        return bookingCol.insertBooking(booking, index);
    }

    public int numberOfBookings() {
        return bookingCol.numberOfBookings();
    }

    public String allBookingsData() {
        return bookingCol.allBookingsData();
    }

    public String toString() {
        return bookingCol.toString();
    }

    public static void main(String[] args) {
        GuestAdministration guestHandler = new GuestAdministration();
        GuestCollection guestCol = guestHandler.getCollection();

        Guest g1 = new Guest("150561-7777", " Miki Boss", "Adult", 2005);
        Guest g2 = new Guest("15081-7777", "Zhen Zhao", "Adult", 2006);
        Guest g3 = new Guest("10080-7777", "Vaida Caiser", "Adult", 2005);

        guestHandler.addGuest(g1);
        guestHandler.addGuest(g2);
        guestHandler.addGuest(g3);
        System.out.println(guestHandler.allGuestsData());

        RoomAdministration roomHandler = new RoomAdministration();
        RoomCatalog roomCat = roomHandler.getCatalog();
        Room r1 = new Room("ISBN: 561-777", "The Boss", "Book", 2003, "Available");
        Room r2 = new Room("ISBN: 562-888", "The Queen", "Book", 2003);
        Room r3 = new Room("ISBN: 563-999", "The Love", "Book", 2003);

        roomCat.addRoom(r1);
        roomCat.addRoom(r2);
        roomCat.addRoom(r3);


        BookingAdministration bookingHandler = new BookingAdministration(guestCol, roomCat);

         Booking b1 = new Booking("23454-3445", "3445fcddd",CalendarCalculator.getDate_From(),CalendarCalculator.getDate_To());
        Booking b2 = new Booking("2a455455", "3dsdfgd", CalendarCalculator.getDate_From(),CalendarCalculator.getDate_To());


        bookingHandler.addBooking(b1);
        bookingHandler.addBooking(b2);
       
        
    }
}
